[API Reference](../README.md) > [ContributionRewardWrapper](../classes/ContributionRewardWrapper.md)



# Class: ContributionRewardWrapper

## Hierarchy


 [ContractWrapperBase](ContractWrapperBase.md)

**↳ ContributionRewardWrapper**







## Index

### Constructors

* [constructor](ContributionRewardWrapper.md#constructor)


### Properties

* [NewContributionProposal](ContributionRewardWrapper.md#NewContributionProposal)
* [ProposalDeleted](ContributionRewardWrapper.md#ProposalDeleted)
* [ProposalExecuted](ContributionRewardWrapper.md#ProposalExecuted)
* [RedeemEther](ContributionRewardWrapper.md#RedeemEther)
* [RedeemExternalToken](ContributionRewardWrapper.md#RedeemExternalToken)
* [RedeemNativeToken](ContributionRewardWrapper.md#RedeemNativeToken)
* [RedeemReputation](ContributionRewardWrapper.md#RedeemReputation)
* [contract](ContributionRewardWrapper.md#contract)
* [factory](ContributionRewardWrapper.md#factory)
* [friendlyName](ContributionRewardWrapper.md#friendlyName)
* [name](ContributionRewardWrapper.md#name)


### Accessors

* [address](ContributionRewardWrapper.md#address)


### Methods

* [getBeneficiaryRewards](ContributionRewardWrapper.md#getBeneficiaryRewards)
* [getController](ContributionRewardWrapper.md#getController)
* [getDaoProposals](ContributionRewardWrapper.md#getDaoProposals)
* [getDefaultPermissions](ContributionRewardWrapper.md#getDefaultPermissions)
* [getParameters](ContributionRewardWrapper.md#getParameters)
* [getParametersArray](ContributionRewardWrapper.md#getParametersArray)
* [getSchemeParameters](ContributionRewardWrapper.md#getSchemeParameters)
* [getSchemeParametersHash](ContributionRewardWrapper.md#getSchemeParametersHash)
* [getSchemePermissions](ContributionRewardWrapper.md#getSchemePermissions)
* [hydrateFromAt](ContributionRewardWrapper.md#hydrateFromAt)
* [hydrateFromDeployed](ContributionRewardWrapper.md#hydrateFromDeployed)
* [hydrateFromNew](ContributionRewardWrapper.md#hydrateFromNew)
* [proposeContributionReward](ContributionRewardWrapper.md#proposeContributionReward)
* [redeemContributionReward](ContributionRewardWrapper.md#redeemContributionReward)
* [redeemEther](ContributionRewardWrapper.md#redeemEther)
* [redeemExternalToken](ContributionRewardWrapper.md#redeemExternalToken)
* [redeemNativeToken](ContributionRewardWrapper.md#redeemNativeToken)
* [redeemReputation](ContributionRewardWrapper.md#redeemReputation)
* [setParameters](ContributionRewardWrapper.md#setParameters)



---
## Constructors
<a id="constructor"></a>


### ⊕ **new ContributionRewardWrapper**(solidityContract: *`any`*): [ContributionRewardWrapper](ContributionRewardWrapper.md)


*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[constructor](ContractWrapperBase.md#constructor)*

*Defined in [contractWrapperBase.ts:46](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L46)*



ContractWrapperFactory constructs this


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| solidityContract | `any`   |  The json contract truffle artifact |





**Returns:** [ContributionRewardWrapper](ContributionRewardWrapper.md)

---


## Properties
<a id="NewContributionProposal"></a>

###  NewContributionProposal

**●  NewContributionProposal**:  *[EventFetcherFactory](../#EventFetcherFactory)[NewContributionProposalEventResult](../interfaces/NewContributionProposalEventResult.md)*  =  this.createEventFetcherFactory<NewContributionProposalEventResult>("NewContributionProposal")

*Defined in [wrappers/contributionReward.ts:42](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L42)*



Events




___

<a id="ProposalDeleted"></a>

###  ProposalDeleted

**●  ProposalDeleted**:  *[EventFetcherFactory](../#EventFetcherFactory)[ProposalDeletedEventResult](../interfaces/ProposalDeletedEventResult.md)*  =  this.createEventFetcherFactory<ProposalDeletedEventResult>("ProposalDeleted")

*Defined in [wrappers/contributionReward.ts:44](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L44)*





___

<a id="ProposalExecuted"></a>

###  ProposalExecuted

**●  ProposalExecuted**:  *[EventFetcherFactory](../#EventFetcherFactory)[ProposalExecutedEventResult](../interfaces/ProposalExecutedEventResult.md)*  =  this.createEventFetcherFactory<ProposalExecutedEventResult>("ProposalExecuted")

*Defined in [wrappers/contributionReward.ts:43](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L43)*





___

<a id="RedeemEther"></a>

###  RedeemEther

**●  RedeemEther**:  *[EventFetcherFactory](../#EventFetcherFactory)[RedeemEventResult](../interfaces/RedeemEventResult.md)*  =  this.createEventFetcherFactory<RedeemEventResult>("RedeemEther")

*Defined in [wrappers/contributionReward.ts:46](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L46)*





___

<a id="RedeemExternalToken"></a>

###  RedeemExternalToken

**●  RedeemExternalToken**:  *[EventFetcherFactory](../#EventFetcherFactory)[RedeemEventResult](../interfaces/RedeemEventResult.md)*  =  this.createEventFetcherFactory<RedeemEventResult>("RedeemExternalToken")

*Defined in [wrappers/contributionReward.ts:48](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L48)*





___

<a id="RedeemNativeToken"></a>

###  RedeemNativeToken

**●  RedeemNativeToken**:  *[EventFetcherFactory](../#EventFetcherFactory)[RedeemEventResult](../interfaces/RedeemEventResult.md)*  =  this.createEventFetcherFactory<RedeemEventResult>("RedeemNativeToken")

*Defined in [wrappers/contributionReward.ts:47](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L47)*





___

<a id="RedeemReputation"></a>

###  RedeemReputation

**●  RedeemReputation**:  *[EventFetcherFactory](../#EventFetcherFactory)[RedeemEventResult](../interfaces/RedeemEventResult.md)*  =  this.createEventFetcherFactory<RedeemEventResult>("RedeemReputation")

*Defined in [wrappers/contributionReward.ts:45](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L45)*





___

<a id="contract"></a>

###  contract

**●  contract**:  *`any`* 

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[contract](ContractWrapperBase.md#contract)*

*Defined in [contractWrapperBase.ts:46](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L46)*



The underlying truffle contract object. Use this to access parts of the contract that aren't accessible via the wrapper.




___

<a id="factory"></a>

###  factory

**●  factory**:  *[ContractWrapperFactory](ContractWrapperFactory.md)[ContributionRewardWrapper](ContributionRewardWrapper.md)*  =  ContributionRewardFactory

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[factory](ContractWrapperBase.md#factory)*

*Defined in [wrappers/contributionReward.ts:36](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L36)*





___

<a id="friendlyName"></a>

###  friendlyName

**●  friendlyName**:  *`string`*  = "Contribution Reward"

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[friendlyName](ContractWrapperBase.md#friendlyName)*

*Defined in [wrappers/contributionReward.ts:35](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L35)*





___

<a id="name"></a>

###  name

**●  name**:  *`string`*  = "ContributionReward"

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[name](ContractWrapperBase.md#name)*

*Defined in [wrappers/contributionReward.ts:34](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L34)*





___


## Accessors
<a id="address"></a>

###  address


getaddress(): [Address](../#Address)

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[address](ContractWrapperBase.md#address)*

*Defined in [contractWrapperBase.ts:41](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L41)*



The address of the contract




**Returns:** [Address](../#Address)



___


## Methods
<a id="getBeneficiaryRewards"></a>

###  getBeneficiaryRewards

► **getBeneficiaryRewards**(options?: *[GetBeneficiaryRewardsParams](../interfaces/GetBeneficiaryRewardsParams.md)*): `Promise`.<`Array`.<[ProposalRewards](../interfaces/ProposalRewards.md)>>



*Defined in [wrappers/contributionReward.ts:357](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L357)*



Return a list of `ProposalRewards` for executed (passed by vote) proposals that have rewards waiting to be redeemed by the given beneficiary. `ProposalRewards` includes both the total amount redeemable and the amount yet-to-be redeemed.


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [GetBeneficiaryRewardsParams](../interfaces/GetBeneficiaryRewardsParams.md)  |  {} as GetBeneficiaryRewardsParams |   - |





**Returns:** `Promise`.<`Array`.<[ProposalRewards](../interfaces/ProposalRewards.md)>>





___

<a id="getController"></a>

###  getController

► **getController**(avatarAddress: *[Address](../#Address)*): `Promise`.<`any`>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[getController](ContractWrapperBase.md#getController)*

*Defined in [contractWrapperBase.ts:142](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L142)*



Returns the controller associated with the given avatar


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<`any`>





___

<a id="getDaoProposals"></a>

###  getDaoProposals

► **getDaoProposals**(options?: *[GetDaoProposalsConfig](../interfaces/GetDaoProposalsConfig.md)*): `Promise`.<`Array`.<[ContributionProposal](../interfaces/ContributionProposal.md)>>



*Defined in [wrappers/contributionReward.ts:313](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L313)*



Return all ContributionReward proposals ever created under the given avatar. Filter by the optional proposalId.


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [GetDaoProposalsConfig](../interfaces/GetDaoProposalsConfig.md)  |  {} as GetDaoProposalsConfig |   - |





**Returns:** `Promise`.<`Array`.<[ContributionProposal](../interfaces/ContributionProposal.md)>>





___

<a id="getDefaultPermissions"></a>

###  getDefaultPermissions

► **getDefaultPermissions**(): [SchemePermissions](../enums/SchemePermissions.md)



*Defined in [wrappers/contributionReward.ts:421](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L421)*





**Returns:** [SchemePermissions](../enums/SchemePermissions.md)





___

<a id="getParameters"></a>

###  getParameters

► **getParameters**(paramsHash: *[Hash](../#Hash)*): `Promise`.<[ContributionRewardParamsReturn](../interfaces/ContributionRewardParamsReturn.md)>



*Overrides [ContractWrapperBase](ContractWrapperBase.md).[getParameters](ContractWrapperBase.md#getParameters)*

*Defined in [wrappers/contributionReward.ts:433](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L433)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| paramsHash | [Hash](../#Hash)   |  - |





**Returns:** `Promise`.<[ContributionRewardParamsReturn](../interfaces/ContributionRewardParamsReturn.md)>





___

<a id="getParametersArray"></a>

###  getParametersArray

► **getParametersArray**(paramsHash: *[Hash](../#Hash)*): `Promise`.<`Array`.<`any`>>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[getParametersArray](ContractWrapperBase.md#getParametersArray)*

*Defined in [contractWrapperBase.ts:134](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L134)*



Given a hash, returns the associated parameters as an array, ordered by the order in which the parameters appear in the contract's Parameters struct.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| paramsHash | [Hash](../#Hash)   |  - |





**Returns:** `Promise`.<`Array`.<`any`>>





___

<a id="getSchemeParameters"></a>

###  getSchemeParameters

► **getSchemeParameters**(avatarAddress: *[Address](../#Address)*): `Promise`.<[ContributionRewardParamsReturn](../interfaces/ContributionRewardParamsReturn.md)>



*Defined in [wrappers/contributionReward.ts:429](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L429)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[ContributionRewardParamsReturn](../interfaces/ContributionRewardParamsReturn.md)>





___

<a id="getSchemeParametersHash"></a>

###  getSchemeParametersHash

► **getSchemeParametersHash**(avatarAddress: *[Address](../#Address)*): `Promise`.<[Hash](../#Hash)>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[getSchemeParametersHash](ContractWrapperBase.md#getSchemeParametersHash)*

*Defined in [contractWrapperBase.ts:124](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L124)*



Given an avatar address, returns the schemes parameters hash


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[Hash](../#Hash)>





___

<a id="getSchemePermissions"></a>

###  getSchemePermissions

► **getSchemePermissions**(avatarAddress: *[Address](../#Address)*): `Promise`.<[SchemePermissions](../enums/SchemePermissions.md)>



*Defined in [wrappers/contributionReward.ts:425](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L425)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[SchemePermissions](../enums/SchemePermissions.md)>





___

<a id="hydrateFromAt"></a>

###  hydrateFromAt

► **hydrateFromAt**(address: *`string`*): `Promise`.<`any`>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[hydrateFromAt](ContractWrapperBase.md#hydrateFromAt)*

*Defined in [contractWrapperBase.ts:76](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L76)*



Initialize from a given address on the current network.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| address | `string`   |  of the deployed contract |





**Returns:** `Promise`.<`any`>
this






___

<a id="hydrateFromDeployed"></a>

###  hydrateFromDeployed

► **hydrateFromDeployed**(): `Promise`.<`any`>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[hydrateFromDeployed](ContractWrapperBase.md#hydrateFromDeployed)*

*Defined in [contractWrapperBase.ts:91](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L91)*



Initialize as it was migrated by Arc.js on the current network.




**Returns:** `Promise`.<`any`>
this






___

<a id="hydrateFromNew"></a>

###  hydrateFromNew

► **hydrateFromNew**(...rest: *`Array`.<`any`>*): `Promise`.<`any`>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[hydrateFromNew](ContractWrapperBase.md#hydrateFromNew)*

*Defined in [contractWrapperBase.ts:60](https://github.com/daostack/arc.js/blob/77005d4/lib/contractWrapperBase.ts#L60)*



Initialize from a newly-migrated instance. This will migrate a new instance of the contract to the net.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| rest | `Array`.<`any`>   |  - |





**Returns:** `Promise`.<`any`>
this






___

<a id="proposeContributionReward"></a>

###  proposeContributionReward

► **proposeContributionReward**(options?: *[ProposeContributionRewardParams](../interfaces/ProposeContributionRewardParams.md)*): `Promise`.<[ArcTransactionProposalResult](ArcTransactionProposalResult.md)>



*Defined in [wrappers/contributionReward.ts:55](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L55)*



Submit a proposal for a reward for a contribution


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ProposeContributionRewardParams](../interfaces/ProposeContributionRewardParams.md)  |  {} as ProposeContributionRewardParams |   - |





**Returns:** `Promise`.<[ArcTransactionProposalResult](ArcTransactionProposalResult.md)>





___

<a id="redeemContributionReward"></a>

###  redeemContributionReward

► **redeemContributionReward**(options?: *[ContributionRewardRedeemParams](../interfaces/ContributionRewardRedeemParams.md)*): `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>



*Defined in [wrappers/contributionReward.ts:164](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L164)*



Redeem the specified rewards for the beneficiary of the proposal


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ContributionRewardRedeemParams](../interfaces/ContributionRewardRedeemParams.md)  |  {} as ContributionRewardRedeemParams |   - |





**Returns:** `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>





___

<a id="redeemEther"></a>

###  redeemEther

► **redeemEther**(options?: *[ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)*): `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>



*Defined in [wrappers/contributionReward.ts:285](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L285)*



Redeem ether reward for the beneficiary of the proposal


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)  |  {} as ContributionRewardSpecifiedRedemptionParams |   - |





**Returns:** `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>





___

<a id="redeemExternalToken"></a>

###  redeemExternalToken

► **redeemExternalToken**(options?: *[ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)*): `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>



*Defined in [wrappers/contributionReward.ts:201](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L201)*



Redeem external token reward for the beneficiary of the proposal


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)  |  {} as ContributionRewardSpecifiedRedemptionParams |   - |





**Returns:** `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>





___

<a id="redeemNativeToken"></a>

###  redeemNativeToken

► **redeemNativeToken**(options?: *[ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)*): `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>



*Defined in [wrappers/contributionReward.ts:257](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L257)*



Redeem native token reward for the beneficiary of the proposal


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)  |  {} as ContributionRewardSpecifiedRedemptionParams |   - |





**Returns:** `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>





___

<a id="redeemReputation"></a>

###  redeemReputation

► **redeemReputation**(options?: *[ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)*): `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>



*Defined in [wrappers/contributionReward.ts:229](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L229)*



Redeem reputation reward for the beneficiary of the proposal


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ContributionRewardSpecifiedRedemptionParams](../interfaces/ContributionRewardSpecifiedRedemptionParams.md)  |  {} as ContributionRewardSpecifiedRedemptionParams |   - |





**Returns:** `Promise`.<[ArcTransactionResult](ArcTransactionResult.md)>





___

<a id="setParameters"></a>

###  setParameters

► **setParameters**(params: *[ContributionRewardParams](../interfaces/ContributionRewardParams.md)*): `Promise`.<[ArcTransactionDataResult](ArcTransactionDataResult.md)[Hash](../#Hash)>



*Overrides [ContractWrapperBase](ContractWrapperBase.md).[setParameters](ContractWrapperBase.md#setParameters)*

*Defined in [wrappers/contributionReward.ts:403](https://github.com/daostack/arc.js/blob/77005d4/lib/wrappers/contributionReward.ts#L403)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| params | [ContributionRewardParams](../interfaces/ContributionRewardParams.md)   |  - |





**Returns:** `Promise`.<[ArcTransactionDataResult](ArcTransactionDataResult.md)[Hash](../#Hash)>





___


